<?php
if ($_POST) {

	function get_file_hashes($files) {
		define('UPLOAD_DIR', './tmp/');
		$hashes = array();
		foreach ($files as $file) {
			if (strlen($file) > 0 && filter_var($file, FILTER_VALIDATE_URL) && check_headers($file)) {
				$hashes[] = get_file_hash($file);
			}
		}
		sort($hashes, SORT_STRING);
		return implode("", $hashes);
	}

	function get_file_hash($file) {
		$length		= 5120;

		$handle		= fopen($file, 'rb');
		$filename	= UPLOAD_DIR . substr(strrchr($file, '/'), 1);
		$write		= fopen($filename, 'w');

		while (!feof($handle)) {
			$buffer = fread($handle, $length);
			fwrite($write, $buffer);
		}

		fclose($handle);
		fclose($write);
		return hash_file("sha256", $filename, FALSE);
	}

	function check_headers($file) {
		$file_headers = @get_headers($file);
		if(!$file_headers || $file_headers[0] == 'HTTP/1.1 404 Not Found') {
			return FALSE;
		} else {
			return TRUE;
		}
	}

	$file_hashes="";
	if(isset($_POST['files'])&&count($_POST['files'])) {
		$file_hashes = get_file_hashes($_POST['files']);
	}

	header("Content-Type: text/plain");
	echo "HASH: " . hash("sha256", filter_var($_POST['data'].$file_hashes.$_POST['salt'], FILTER_SANITIZE_STRING));
} else { ?>
	<!doctype html>
	<head>
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1" />
		<title>Verificación</title>
		<link href="https://fonts.googleapis.com/css?family=Roboto+Condensed" rel="stylesheet">
		<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
		<style>
			*{
				margin: 0;
				padding: 0;
			}
			html{
				margin: 0;
			}
			body{
				font-size: 62.3%;
				font-family: 'Open Sans', sans-serif;
				background: #444;
				background: url(bg.png);
				color: #333;
				margin: 20px 0;
			}
			h1, h2, h3, h4{
				line-height: 120%;
				margin: 1.5em 0 0.5em;
				font-weight: 300;
			}
			h1{
				font-size: 360%;
				margin: 1.0em 0 0.5em;
				vertical-align: middle;
				color: #ccc;
			}
			h1 strong{
				font-size: 130%;
				color: #fff;
			}
			a{
				outline: none;
				color: #7792c8;
				cursor: pointer;
			}
			a:hover{
				color: #222;
			}
			a:focus {
				outline:0;
			}
			a:hover,
			a:active {
				outline:0;
			}
			.center{
				text-align: center;
			}
			.sf{
				clear: both;
			}
			form{
				margin: 0;
				padding: 0;
			}
			.form{
				width: 56%;
				padding: 20px 2%;
				margin: 0 auto;
				background: #eee url(avanzado.png) repeat-x bottom;
				border-radius: 6px;
				position: relative;
				box-shadow: 0px 3px 5px #000;
			}
			form h1{
				color: #999;
				font-size: 300%;
				margin: 0.2em 0 0.8em;
				text-align: center;
				font-weight: 700;
				text-transform: uppercase;
				letter-spacing: -1px;
			}
			label{
				display: block;
				font-size: 150%;
				line-height: 140%;
				margin: 1.5em 0 0.3em 0;
				color: #333;
			}
			input, textarea{
				font-size: 14px;
				width: 96%;
				border: 1px #ccc solid;
				padding: 6px 2%;
			}
			textarea{
				height: 200px;
			}
			button{
				border: 0;
			/*	font-size: 14px;
				border: 1px #ccc solid;
				padding: 6px	;
				width: 10%;
				margin: 0 0 0 90%;*/
			}
			.form-group{
				margin: 0px;
			}
			.btn{
				font-size: 120%;
				font-weight: 600;
				text-transform: uppercase;
				color: #fff;
				padding: 8px 15px;
				margin: 5px 0;
				text-decoration: none;
				border-radius: 5px;
				display: inline-block;
				background: #4285F4;
				border-bottom: 2px solid rgba(0,0,0,0.05);
			}
			.btn:hover{
				/*color: rgba(0,0,0,0.5);*/
				color: #fff;
				border-bottom: 2px solid rgba(0,0,0,0.1);
			}
			.btn i{
				margin: 0;
				line-height: 100%;
			}
			.btn.warning{
				background: #ffbb33;
			}
		</style>
	</head>
	<body>
	<form method="POST" action="hasher.php">
		<div class="form">
			<h1>Verificar certificado en Blockchain</h1>
				<input name="id" type="hidden" value="1">
			<div class="form-group">
				<label class="control-label">Salt</label>
				<input name="salt" type="text">
			</div>
			<div class="form-group">
				<label class="control-label">Texto de la certificación</label>
				<textarea name="data"></textarea>
			</div>
			<div class="form-group">
				<label class="control-label">Archivos de la certificación</label>
				<div id="files_box"><input name="files[]" type="url" placeholder="Ruta del archivo"></div>
				<span style="float: right;"><a id="addfile">Agregar archivo</a></span>
			</div>


			<div class="center sf">
				<button type="submit" class="btn warning">Enviar</button>
			</div>
		</div>
	</form>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
	<script>
	var bcaas= {

		'init': function(){

			$('#addfile').click(function(){
				var fileinput=$('#files_box input').first().clone().val('');
				fileinput.appendTo('#files_box');
			});

		}

	}
	bcaas.init();
	</script>
	</body>
	</html>
<?php } ?>